#include "config.h"
#include "DssslApp.h"
#include "SgmlFOTBuilder.h"
#include "RtfFOTBuilder.h"
#include "HtmlFOTBuilder.h"
#include "TeXFOTBuilder.h"
#include "TransformFOTBuilder.h"
#include "MifFOTBuilder.h"
#include "OutputCharStream.h"
#include "macros.h"
#include "sptchar.h"
#include "JadeMessages.h"
#include "ErrnoMessageArg.h"
#include "OutputByteStream.h"

#include <errno.h>

#ifdef BUILD_LIBJADE
#define JADE_API SP_DLLEXPORT
#else /* not BUILD_LIBJADE */
#ifdef JADE_USE_DLL
#define JADE_API SP_DLLIMPORT
#else /* not BUILD_LIBJADE, not JADE_USE_DLL */
#define JADE_API /* as nothing */
#endif
#endif

#ifdef DSSSL_NAMESPACE
namespace DSSSL_NAMESPACE {
#endif

class JADE_API JadeApp : public DssslApp {
public:
  enum { u = 72000 };
  JadeApp();
  void processOption(AppChar opt, const AppChar *arg);
  FOTBuilder *makeFOTBuilder(const FOTBuilder::Extension *&);
private:
  enum OutputType { fotType, rtfType, htmlType, texType, sgmlType, xmlType, mifType };
  static const AppChar *const outputTypeNames[];
  OutputType outputType_;
  String<AppChar> outputFilename_;
  Vector<StringC> outputOptions_;
  FileOutputByteStream outputFile_;
};

#ifdef DSSSL_NAMESPACE
}
#endif
